# -*- coding: utf-8 -*-
try:
    from repoze.what.middleware import setup_auth
except ImportError:
    raise ImportError('repoze.what is required')
from repoze.who.plugins.basicauth import BasicAuthPlugin
from afpy.ldap.connection import Connection
from afpy.ldap import auth
import os

class GroupAdapter(auth.BaseSourceAdapter):
    """Group adapter. Everybody is in hg group
    """

    def __init__(self, conn):
        self.conn = conn
        self.klass = conn.user_class

    def _get_all_sections(self):
        raise NotImplementedError()

    def _get_section_items(self, section):
        raise NotImplementedError()
        #users = self.conn.view('auth/group_users', key=section)
        #return [doc['_id'] for doc in users]

    def _find_sections(self, hint):
        return ['hg']
        uid = hint.get('repoze.what.userid')
        if uid and isinstance(uid, basestring):
            user = self.conn.get_user(uid)
            return user.groups
        return []

    def _include_items(self, section, items):
        raise NotImplementedError()

    def _item_is_included(self, section, item):
        raise NotImplementedError()

    def _section_exists(self, section):
        raise NotImplementedError()

class PermissionAdapter(auth.BaseSourceAdapter):
    """Permission adapter. Every logged user can read and push
    """

    def __init__(self, conn):
        self.conn = conn

    def _get_all_sections(self):
        raise NotImplementedError()

    def _get_section_items(self, section):
        raise NotImplementedError()

    def _find_sections(self, hint):
        return ['allow_read', 'allow_push']
        #group = self.conn.get_group(hint, node_class=self.conn.group_class)
        #return [v.cn for v in self.conn.get_groups(group.dn) if v.cn]

    def _include_items(self, section, items):
        raise NotImplementedError()

    def _item_is_included(self, section, item):
        raise NotImplementedError()

    def _section_exists(self, section):
        raise NotImplementedError()

def make_auth_basic(app, global_config, conn=None, **local_conf):
    """Paste entry point for auth basic middleware using repoze.what"""

    if not conn:
        section = local_conf.get('section', 'alterway')
        config_file = local_conf.get('config', os.path.expanduser('~/.ldap.cfg'))
        conn = Connection(section, filename=config_file)

    authenticator=auth.Authenticator(conn)

    groups = GroupAdapter(conn)
    groups = {'all_groups': groups}

    basicauth = BasicAuthPlugin('Private web site')
    identifiers=[("basicauth", basicauth)]
    challengers=[("basicauth", basicauth)]

    authenticators=[("accounts", authenticator)]
    mdproviders=[("accounts", auth.MDPlugin(conn))]

    permissions = {'all_perms': PermissionAdapter(conn)}

    return setup_auth(app,
                      groups,
                      permissions,
                      identifiers=identifiers,
                      authenticators=authenticators,
                      challengers=challengers,
                      mdproviders=mdproviders)


